#===============================================================================
#    ProVerif Editor
#    Copyright (C) 2009 Joeri de Ruiter
# 
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
# 
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
# 
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#===============================================================================

class IntervalSet():
    def __init__(self):
        self.list = []
        
    def add(self, start, end, value):
        if len(self.list) == 0:
            self.list.insert(0, Interval(start, end, value))
        else:
            i = 0
            current = self.list[0]
            while (current.start < start) & (i < len(self.list) - 1):
                i = i + 1
                current = self.list[i]
            
            if (current.end < end) & (current.start > end):
                raise Exception('Overlapping intervals')
            
            if (current.end < start):
                i += 1
                
            self.list.insert(i, Interval(start, end, value))
                        
    def get(self, value):
        if len(self.list) == 0:
            return None
        else:
            i = 0
            current = self.list[0]
            while (current.end < value) & (i < (len(self.list) - 1)):
                i = i + 1
                current = self.list[i]
            
            if (current.start <= value) & (value <= current.end):
                return current.value
            
            return None 
                    
    def __str__(self):
        string = '[' + ', '.join(self.list) + ']'
        return string
        
class Interval():
    def __init__(self, start, end, value):
        self.start = start
        self.end = end
        self.value = value
    
    def __str__(self):
        return '{' + str(self.start) + ', ' + str(self.end) + ', ' + str(self.value) + '}'
        